-- NOTE: THIS SCRIPT MUST BE RUN IN SQLCMD MODE TO FUNCTION PROPERLY
:CONNECT Buzz

-- Switch to the InitiatorDB database
USE InitiatorDB;
GO

-- Start a conversation and send a request message
DECLARE @conversation_handle UNIQUEIDENTIFIER;
DECLARE @request_message_body NVARCHAR(100);

BEGIN TRANSACTION;

BEGIN DIALOG @conversation_handle
	FROM SERVICE [//MultipleInstances/InitiatorService]
	TO SERVICE N'//MultipleInstances/TargetService'
	ON CONTRACT [//MultipleInstances/SimpleContract]
	WITH ENCRYPTION = ON;

	

SELECT @request_message_body = N'<RequestMsg>Message for Target service.</RequestMsg>';

SEND ON CONVERSATION @conversation_handle
     MESSAGE TYPE [//MultipleInstances/RequestMessage]
     (@request_message_body);

SELECT @request_message_body AS SentRequestMsg;

COMMIT TRANSACTION;
GO

-- Receive the request and send a reply - the remote service automatically activates
-- and handles the message sending the reply back so we can handle it.
-- Receive the reply and end the conversation
DECLARE @message_body NVARCHAR(100);
DECLARE @conversation_handle UNIQUEIDENTIFIER;

BEGIN TRANSACTION;

WAITFOR
( RECEIVE TOP(1)
    @conversation_handle = conversation_handle,
    @message_body = message_body
  FROM InitiatorQueue
), TIMEOUT 1000;

END CONVERSATION @conversation_handle;

-- Display recieved request.
SELECT @message_body AS ReceivedReplyMsg;

COMMIT TRANSACTION;
GO