USE TargetDB;
GO
--Creating event notification queue
--which will hold notification messages
--raised by MultiDB_Broker_TargetQueue and will be
--consumed by External Activator
CREATE QUEUE dbo.EAS_NotificationQueue 
GO

--Creating event notification service
--which will be used to send notification messages
CREATE SERVICE EAS_NotificationService
ON QUEUE dbo.EAS_NotificationQueue
(
    [http://schemas.microsoft.com/SQL/Notifications/PostEventNotification]
)
GO


--Create an event notification for QUEUE_ACTIVATION event on 
--the queue MultiDB_Broker_TargetQueue to notify service EAS_NotificationService 
CREATE EVENT NOTIFICATION EAS_QueueEventNotification
ON QUEUE MultiDB_Broker_TargetQueue
FOR QUEUE_ACTIVATION
TO SERVICE 'EAS_NotificationService', 'current database'
GO
