-- NOTE: THIS SCRIPT MUST BE RUN IN SQLCMD MODE TO FUNCTION PROPERLY
:CONNECT Woody

-- Create references to initiator objects
USE TargetDB
GO
CREATE USER InitiatorUser WITHOUT LOGIN;
GO

-- Copy initiator certificate to local folder
CREATE CERTIFICATE InitiatorCertificate
AUTHORIZATION InitiatorUser
FROM FILE = N'\\Buzz\Backups\InitiatorCertificate.cer';
GO

GRANT SEND ON SERVICE::[//MultipleInstances/TargetService] TO InitiatorUser;
GO

CREATE REMOTE SERVICE BINDING InitiatorBinding
TO SERVICE N'//MultipleInstances/InitiatorService'
WITH USER = InitiatorUser;
GO

:CONNECT BUZZ
SELECT name, service_broker_guid
FROM sys.databases
WHERE is_broker_enabled = 1
GO


-- NOTE: THIS SCRIPT MUST BE RUN IN SQLCMD MODE TO FUNCTION PROPERLY
:CONNECT Woody
-- Create routes
-- The following CREATE ROUTE statements assume that there are no duplicate 
-- service names in the target instance. If multiple databases on the target 
-- instance contain services that have the same name, use the BROKER_INSTANCE 
-- clause to specify the database on which you want to open a conversation.
USE TargetDB;
GO

IF EXISTS (SELECT *
		   FROM sys.routes
		   WHERE name = N'InitiatorRoute')
	DROP ROUTE InitiatorRoute;
GO

CREATE ROUTE InitiatorRoute
WITH SERVICE_NAME = N'//MultipleInstances/InitiatorService',
	 ADDRESS = N'TCP://Buzz.SQLskillsDemos.com:4022',
	 BROKER_INSTANCE = '5BEA311D-7339-4EB5-84BD-0CCDCB5C46D2';
GO


USE msdb;
GO

IF EXISTS (SELECT *
		   FROM sys.routes
		   WHERE name = N'TargetRoute')
	DROP ROUTE TargetRoute;
GO

CREATE ROUTE TargetRoute
WITH SERVICE_NAME = N'//MultipleInstances/TargetService',
     ADDRESS = N'LOCAL';
GO
