-- NOTE: THIS SCRIPT MUST BE RUN IN SQLCMD MODE TO FUNCTION PROPERLY
:CONNECT Woody

-- Create references to initiator objects
USE TargetDB
GO
CREATE USER InitiatorUser WITHOUT LOGIN;
GO

-- Copy initiator certificate to local folder
CREATE CERTIFICATE InitiatorCertificate
AUTHORIZATION InitiatorUser
FROM FILE = N'\\Woody\Backups\InitiatorCertificate.cer';
GO

-- Create routes
-- The following CREATE ROUTE statements assume that there are no duplicate 
-- service names in the target instance. If multiple databases on the target 
-- instance contain services that have the same name, use the BROKER_INSTANCE 
-- clause to specify the database on which you want to open a conversation.
USE TargetDB;
GO

CREATE ROUTE InitiatorRoute
WITH SERVICE_NAME = N'//MultipleInstances/InitiatorService',
	 ADDRESS = N'TCP://Buzz.SQLskillsDemos.com:4022';
GO


USE msdb;
GO

IF EXISTS (SELECT *
		   FROM sys.routes
		   WHERE name = N'TargetRoute')
	DROP ROUTE TargetRoute;
GO

CREATE ROUTE TargetRoute
WITH SERVICE_NAME = N'//MultipleInstances/TargetService',
     ADDRESS = N'LOCAL';
GO

USE TargetDB;
GO

GRANT SEND ON SERVICE::[//MultipleInstances/TargetService] TO InitiatorUser;
GO

CREATE REMOTE SERVICE BINDING InitiatorBinding
TO SERVICE N'//MultipleInstances/InitiatorService'
WITH USER = InitiatorUser;
GO